From 5834a02880d13c771a14f2bdeaff02c1be17ed17 Mon Sep 17 00:00:00 2001
From: Matheus Alcantara <mths.dev@pm.me>
Date: Wed, 29 Jul 2026 15:37:05 -0300
Subject: [PATCH v9 21/21] Rework hashjoin Bloom filter selection

, and size filters for cheap probes

The filter-pushdown code picked and costed filter candidates in a way
that could build a filter per subset and treated filtering as free, and
it sized the filters for accuracy rather than for cheap probing. This
commit reworks both.

Candidate selection and costing:

* Drop the count-based candidate cap. find_interesting_bloom_filters()
  now returns every candidate that clears
  bloom_filter_pushdown_threshold instead of trimming to the
  bloom_filter_pushdown_max most selective ones. Selectivity, not an
  arbitrary count, decides what is interesting.

* Cost filter-aware scan paths for real. Paths are built through the
  normal create_*_path constructors, and apply_expected_filters()
  charges one cpu_operator_cost per filter per tuple, so filtering is no
  longer modeled as free.  A filter is chosen only when the resulting
  path is actually cheaper.

* Apply all candidates at once instead of enumerating subsets. A single
  combination applies all non-overlapping candidates
  most-selective-first, so we no longer build one path per subset.
  bloom_filter_pushdown_max is repurposed to bound how many filters are
  applied simultaneously (the per-tuple probe cost), and the now-unused
  combination_floor GUC is removed.  This avoids the path explosion and
  keeps planning time bounded.

* Add an IndexPath filter variant. create_filtered_scan_path() clones
  the source IndexPath, reusing its indexclauses and pathkeys, and
  applies the same probe-cost and row adjustment as the other scan
  types.

* Cache the interesting filters on the RelOptInfo so
  find_interesting_bloom_filters() runs once per rel, instead of being
  recomputed for core path generation and again by a CustomScan
  provider.

* Export find_bloom_filter_combinations() and apply_expected_filters()
  so a CustomScan provider can build its own filter-aware paths, rather
  than having core construct CustomPaths on its behalf.

Filter sizing:

* Size hashjoin filters for cheap probes. The filters were built with
  bloom_create(), whose sizing favors accuracy: a 1MB bitset floor and
  up to MAX_HASH_FUNCS (10) hash functions.  That is wrong for a filter
  that probes a large apply side.  A filter probing tens of millions of
  rows then does ~10 random accesses into a bitset that does not fit in
  L2, so each probe is effectively a series of cache misses -- it is no
  longer the cheap constant-k operation the cost model assumes, and the
  filter can cost more than it saves even while rejecting most of the
  rows.

  Add bloom_create_probe() alongside bloom_create() (both share a static
  bloom_create_internal(), differing only in the bitset floor and the
  hash-function cap).  Callers that need accuracy keep the 1MB / 10-hash
  sizing; the hashjoin filters in nodeHash.c use bloom_create_probe(),
  which uses a 1KB floor and caps the hash functions at 4.  The filter
  is then sized to the build side and stays cache-resident, so the
  per-tuple probe is genuinely cheap.
---
 .../pg_plan_advice/expected/join_order.out    |  60 ++--
 .../expected/pg_stash_advice.out              |  98 +++---
 .../postgres_fdw/expected/postgres_fdw.out    |  42 +--
 src/backend/executor/nodeHash.c               |  53 ++-
 src/backend/lib/bloomfilter.c                 |  16 +-
 src/backend/optimizer/path/allpaths.c         | 317 ++++++++++--------
 src/backend/optimizer/path/costsize.c         |  14 +-
 src/backend/optimizer/path/indxpath.c         |   4 +-
 src/backend/optimizer/path/tidpath.c          |   8 +-
 src/backend/optimizer/plan/planner.c          |   2 +-
 src/backend/optimizer/util/pathnode.c         | 147 ++++----
 src/backend/utils/misc/guc_parameters.dat     |   4 +-
 src/backend/utils/misc/postgresql.conf.sample |   4 +-
 src/include/lib/bloomfilter.h                 |   4 +
 src/include/nodes/pathnodes.h                 |  10 +
 src/include/optimizer/pathnode.h              |  15 +-
 src/include/optimizer/paths.h                 |   1 +
 .../expected/test_bloom_customscan.out        |  92 ++++-
 .../sql/test_bloom_customscan.sql             |  51 ++-
 .../test_bloom_customscan.c                   |  74 ++--
 src/test/regress/expected/hashjoin_bloom.out  |   8 +-
 .../expected/hashjoin_bloom_snowflake.out     |  38 +--
 .../regress/expected/hashjoin_bloom_star.out  | 108 +++---
 src/test/regress/expected/join.out            |  74 ++--
 src/test/regress/expected/misc_functions.out  |  14 +-
 src/test/regress/expected/returning.out       |   4 +-
 src/test/regress/expected/select_parallel.out |  37 +-
 27 files changed, 779 insertions(+), 520 deletions(-)

diff --git a/src/backend/executor/nodeHash.c b/src/backend/executor/nodeHash.c
index 56d15890a9c..41a6a3431bb 100644
--- a/src/backend/executor/nodeHash.c
+++ b/src/backend/executor/nodeHash.c
@@ -82,6 +82,17 @@ static bool ExecParallelHashTuplePrealloc(HashJoinTable hashtable,
 static void ExecParallelHashMergeCounters(HashJoinTable hashtable);
 static void ExecParallelHashCloseBatchAccessors(HashJoinTable hashtable);
 
+static bloom_filter *bloom_create_probe(int64 total_elems, int bloom_work_mem, uint64 seed);
+
+
+/*
+ * Sizing for probe-oriented Bloom filters. A small bitset floor, so small
+ * build sides stay resident in CPU cache, and a low cap on the number of hash
+ * functions, since each is an independent (potentially cache-missing) bitset
+ * access on every probe.
+ */
+#define BLOOM_PROBE_MIN_BITSET_BYTES	1024
+#define BLOOM_PROBE_MAX_HASH_FUNCS		4
 
 /* ----------------------------------------------------------------
  *		ExecHash
@@ -714,8 +725,10 @@ ExecHashTableCreate(HashState *state)
 	 * same lifecycle (during rescans, etc.).
 	 *
 	 * The size of the filter is bounded by both the estimated inner row count
-	 * and a fixed fraction of work_mem.  bloom_create() will round down to
-	 * the next power-of-two bitset and enforces a 1MB minimum.
+	 * and a fixed fraction of work_mem.  We use bloom_create_probe(), which
+	 * (unlike bloom_create) sizes the bitset to the build side without a 1MB
+	 * floor and caps the hash-function count, so the filter stays small
+	 * enough to be cache-resident and cheap to probe per tuple.
 	 *
 	 * XXX This may need more thought. If we limit bloom_work_mem too much,
 	 * the false positive rate will get too bad, and we won't filter enough
@@ -739,8 +752,8 @@ ExecHashTableCreate(HashState *state)
 		bloom_work_mem = Max(1024, work_mem / 8);
 
 		oldctx = MemoryContextSwitchTo(hashtable->hashCxt);
-		state->bloom_filter = bloom_create((int64) Max(rows, 1.0),
-										   bloom_work_mem, 0);
+		state->bloom_filter = bloom_create_probe((int64) Max(rows, 1.0),
+												 bloom_work_mem, 0);
 
 		/*
 		 * If a recipient opted in, also build one filter per join key (in
@@ -753,8 +766,8 @@ ExecHashTableCreate(HashState *state)
 			state->perkey_filters = palloc_array(struct bloom_filter *,
 												 state->perkey_nfilters);
 			for (int i = 0; i < state->perkey_nfilters; i++)
-				state->perkey_filters[i] = bloom_create((int64) Max(rows, 1.0),
-														bloom_work_mem, 0);
+				state->perkey_filters[i] = bloom_create_probe((int64) Max(rows, 1.0),
+															  bloom_work_mem, 0);
 		}
 
 		MemoryContextSwitchTo(oldctx);
@@ -3784,3 +3797,31 @@ get_hash_memory_limit(void)
 
 	return (size_t) mem_limit;
 }
+
+/*
+ * Create a Bloom filter tuned for repeated per-tuple probing within a query,
+ * rather than one built once and checked in bulk.
+ *
+ * bloom_create's sizing is a poor fit for that use in two ways, both of which
+ * make each probe expensive:
+ *
+ * - Size.  bloom_create enforces a 1MB minimum bitset, which for a typical
+ *   build side does not fit in the CPU's L2 cache, so every probe of a large
+ *   scan incurs cache misses.  Here we drop that floor and let the bitset be
+ *   sized to the build side, so small build sides yield cache-resident filters.
+ *
+ * - Hash functions.  Each of the k hash functions is an independent random
+ *   access into the bitset, so a high k means many (cache-missing) accesses per
+ *   probe.  We cap k well below MAX_HASH_FUNCS, trading a slightly higher
+ *   false-positive rate for much cheaper probes.
+ *
+ * This mirrors the "small fixed number of hash functions" and "keep the filter
+ * within the L2 cache" choices in the bottom-up Bloom filter paper.
+ */
+bloom_filter *
+bloom_create_probe(int64 total_elems, int bloom_work_mem, uint64 seed)
+{
+	return bloom_create_custom(total_elems, bloom_work_mem,
+							   BLOOM_PROBE_MIN_BITSET_BYTES,
+							   BLOOM_PROBE_MAX_HASH_FUNCS, seed);
+}
diff --git a/src/backend/lib/bloomfilter.c b/src/backend/lib/bloomfilter.c
index fbcf788e271..9f2f9006ab7 100644
--- a/src/backend/lib/bloomfilter.c
+++ b/src/backend/lib/bloomfilter.c
@@ -84,7 +84,8 @@ static inline uint32 mod_m(uint32 val, uint64 m);
  * 0.  Callers can also use a pseudo-random seed, eg from pg_prng_uint64().
  */
 bloom_filter *
-bloom_create(int64 total_elems, int bloom_work_mem, uint64 seed)
+bloom_create_custom(int64 total_elems, int bloom_work_mem,
+					  uint64 min_bitset_bytes, int max_hash_funcs, uint64 seed)
 {
 	bloom_filter *filter;
 	int			bloom_power;
@@ -99,7 +100,7 @@ bloom_create(int64 total_elems, int bloom_work_mem, uint64 seed)
 	 * false positive rate still won't exceed 2% in almost all cases.
 	 */
 	bitset_bytes = Min(bloom_work_mem * UINT64CONST(1024), total_elems * 2);
-	bitset_bytes = Max(1024 * 1024, bitset_bytes);
+	bitset_bytes = Max(min_bitset_bytes, bitset_bytes);
 
 	/*
 	 * Size in bits should be the highest power of two <= target.  bitset_bits
@@ -112,13 +113,22 @@ bloom_create(int64 total_elems, int bloom_work_mem, uint64 seed)
 	/* Allocate bloom filter with unset bitset */
 	filter = palloc0(offsetof(bloom_filter, bitset) +
 					 sizeof(unsigned char) * bitset_bytes);
-	filter->k_hash_funcs = optimal_k(bitset_bits, total_elems);
+	filter->k_hash_funcs = Min(optimal_k(bitset_bits, total_elems),
+							   max_hash_funcs);
 	filter->seed = seed;
 	filter->m = bitset_bits;
 
 	return filter;
 }
 
+bloom_filter *
+bloom_create(int64 total_elems, int bloom_work_mem, uint64 seed)
+{
+	return bloom_create_custom(total_elems, bloom_work_mem,
+								 UINT64CONST(1024) * 1024, MAX_HASH_FUNCS,
+								 seed);
+}
+
 /*
  * Free Bloom filter
  */
diff --git a/src/backend/optimizer/path/allpaths.c b/src/backend/optimizer/path/allpaths.c
index 62000d9fe58..4bef76c086a 100644
--- a/src/backend/optimizer/path/allpaths.c
+++ b/src/backend/optimizer/path/allpaths.c
@@ -877,7 +877,7 @@ set_plain_rel_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
 		return;
 
 	/* Consider sequential scan */
-	add_path(rel, create_seqscan_path(root, rel, required_outer, 0));
+	add_path(rel, create_seqscan_path(root, rel, required_outer, 0, NIL));
 
 	/* If appropriate, consider parallel sequential scan */
 	if (rel->consider_parallel && required_outer == NULL)
@@ -904,7 +904,7 @@ create_plain_partial_paths(PlannerInfo *root, RelOptInfo *rel)
 		return;
 
 	/* Add an unordered partial path based on a parallel sequential scan. */
-	add_partial_path(rel, create_seqscan_path(root, rel, NULL, parallel_workers));
+	add_partial_path(rel, create_seqscan_path(root, rel, NULL, parallel_workers, NIL));
 }
 
 /*
@@ -1096,9 +1096,10 @@ bloom_build_side_join_ratio(PlannerInfo *root, List *build_sides,
  * fraction is estimated as the semijoin selectivity of those clauses.
  *
  * A candidate is "interesting" only if it is expected to eliminate at least
- * bloom_filter_pushdown_threshold of the rel's tuples.  We keep at most
- * bloom_filter_pushdown_max of the most selective candidates, and return them
- * as a list of ExpectedFilter nodes.
+ * bloom_filter_pushdown_threshold of the rel's tuples.  Every candidate that
+ * clears that bar is returned as an ExpectedFilter node; deciding which of
+ * them to actually combine into a scan path (and how many) is left to
+ * find_bloom_filter_combinations().
  *
  * XXX This needs to be careful to not interfere with the general selectivity
  * estimation, performed by clauselist_selectivity(). We'll estimate the filter
@@ -1128,6 +1129,15 @@ find_interesting_bloom_filters(PlannerInfo *root, RelOptInfo *rel)
 	if (rel->reloptkind != RELOPT_BASEREL)
 		return NIL;
 
+	/*
+	 * Return the cached result if we've already computed the interesting
+	 * filters for this rel. Both core path generation and a CustomScan
+	 * provider may ask for them, and the enumeration/selectivity work below
+	 * is not free, so we do it only once per base relation.
+	 */
+	if (rel->bloom_filters_valid)
+		return rel->bloom_filters;
+
 	/* Collect candidate hashjoinable equality clauses for this rel. */
 	candidates = generate_implied_equalities_for_all_columns(root, rel,
 															 bloom_em_matches_anybarevar,
@@ -1419,34 +1429,13 @@ find_interesting_bloom_filters(PlannerInfo *root, RelOptInfo *rel)
 	}
 
 	/*
-	 * We have collected all potentially intresting filters. Evaluate
-	 * selectivity of each group and keep only the most interesting filters.
-	 * Filters have to eliminate at least bloom_filter_pushdown_threshold
-	 * tuples, and we keep only bloom_filter_pushdown_max most selective ones.
-	 *
-	 * We only connsider a limited number of interesting filters, to prevent
-	 * path explosion. If we found too many, keep only the most selective ones
-	 * (with smallest surviving fraction of tuples), to bound the number of
-	 * generated paths.
-	 *
-	 * XXX This also aligns with good join orders - those tend to perform the
-	 * most selective joins first. So we get to build the filters soon, even
-	 * if the hashjoin optimization is not disabled.
+	 * Return every candidate that clears bloom_filter_pushdown_threshold.
+	 * Which of them to combine into a scan path, and how many, is decided by
+	 * find_bloom_filter_combinations(); a filter that is weak on its own can
+	 * still be useful combined with others, or to a smart consumer.
 	 */
-	while (list_length(result) > bloom_filter_pushdown_max)
-	{
-		ExpectedFilter *worst = NULL;
-		ListCell   *lcw;
-
-		foreach(lcw, result)
-		{
-			ExpectedFilter *f = (ExpectedFilter *) lfirst(lcw);
-
-			if (worst == NULL || f->selectivity > worst->selectivity)
-				worst = f;
-		}
-		result = list_delete_ptr(result, worst);
-	}
+	rel->bloom_filters = result;
+	rel->bloom_filters_valid = true;
 
 	return result;
 }
@@ -1456,59 +1445,40 @@ find_interesting_bloom_filters(PlannerInfo *root, RelOptInfo *rel)
  *		Generate additional scan paths that anticipate one or more pushed-down
  *		Bloom filters.
  *
- * For each non-empty subset of the interesting filters, we clone every eligible
- * existing scan path, reducing its row estimate by the combined selectivity and
- * attaching the corresponding ExpectedFilter nodes.
+ * For each combination of the interesting filters (see
+ * find_bloom_filter_combinations), we build a new path via the real
+ * constructor for that path's type, passing the filters in so the
+ * constructor's apply_expected_filters() call charges a per-tuple probe cost.
+ *
+ * IndexPath is the one exception: it goes through create_filtered_scan_path,
+ * which clones the source path, because create_index_path() would re-derive
+ * its indexclauses/pathkeys from scratch for no benefit (see the comment on
+ * create_filtered_scan_path).
  *
  * These paths are kept alongside the regular paths (add_path keeps paths with
  * differing expected_filters) and are consumed by join path generation;
  * set_cheapest never selects them.
  *
- * XXX We must not clone paths that already have expected filters.
- *
- * XXX The cloning is a rather dirty way to copy paths. It does not readjust the
- * cost in a reasonable way. For example custom scans could do something smart
- * with the filters, so it should have a chance to deal with that. A cleaner
- * solution might be to actually pass the filters to the various "create"
- * function, like create_seqscan_path/... For CustomScan nodes we can probably
- * do most of this in the set_rel_pathlist_hook, somewhere. Maybe that needs
- * some helper methods, though. And maybe it will need to pass some of the info
- * through the callbacks? Not sure, someone has to try that.
- *
- * XXX This may need some major changes to work with custom scans. Right now we
- * only consider filters exactly matching the hash keys, so if the hashjoin is
- * on (t1.a = t2.a AND t1.b = t2.b), then the filter will be on (a,b). But a
- * custom scan may prefer "split" filters on each column independently. We'd
- * need a way for the custom scan to indicate that, and we'd need to apply this
- * only to the "matching" scan paths (and not to any other scan paths). But
- * we only look at the paths after selecting the "interesting" filters, so we'd
- * need to rethink that - we'd need to make the "interesting" filters specific
- * to a path, or something like that.
+ * CustomPath is not handled here at all.  Core cannot safely copy or construct
+ * a CustomPath, so a provider that wants filter-aware CustomPaths must build
+ * them itself, inside its own set_rel_pathlist_hook, by calling
+ * find_bloom_filter_combinations() directly and costing the result however it
+ * likes -- with real smart costing, or by calling apply_expected_filters() on
+ * its own freshly-built CustomPath if it doesn't want to be smart.
  */
 static void
 generate_expected_filter_paths(PlannerInfo *root, RelOptInfo *rel)
 {
-	List	   *filters;
+	List	   *combinations;
 	List	   *basepaths = NIL;
-	int			nfilters;
-	uint32		combo;
-	ListCell   *lc;
-
-	filters = find_interesting_bloom_filters(root, rel);
-	if (filters == NIL)
-		return;
-
-	nfilters = list_length(filters);
 
 	/*
 	 * Snapshot the existing unparameterized, non-partial scan paths of a
 	 * supported type.  We must snapshot before calling add_path(), which
 	 * mutates rel->pathlist.
 	 */
-	foreach(lc, rel->pathlist)
+	foreach_ptr(Path, path, rel->pathlist)
 	{
-		Path	   *path = (Path *) lfirst(lc);
-
 		/* XXX Is parameterization really a problem? Always? */
 		if (path->param_info != NULL || path->expected_filters != NIL)
 			continue;
@@ -1522,19 +1492,6 @@ generate_expected_filter_paths(PlannerInfo *root, RelOptInfo *rel)
 			case T_TidRangePath:
 				basepaths = lappend(basepaths, path);
 				break;
-			case T_CustomPath:
-
-				/*
-				 * A base-relation CustomScan can receive a pushed-down
-				 * filter, but only if the provider advertised that it knows
-				 * how to consume one (it probes the filter itself inside its
-				 * scan loop; see find_bloom_filter_recipient in createplan.c
-				 * and ExecInitCustomScan).  Providers that don't opt in, like
-				 * heap, are unaffected.
-				 */
-				if (((CustomPath *) path)->flags & CUSTOMPATH_SUPPORT_BLOOM_FILTERS)
-					basepaths = lappend(basepaths, path);
-				break;
 			default:
 				break;
 		}
@@ -1543,79 +1500,155 @@ generate_expected_filter_paths(PlannerInfo *root, RelOptInfo *rel)
 	if (basepaths == NIL)
 		return;
 
+	combinations = find_bloom_filter_combinations(root, rel);
+	if (combinations == NIL)
+		return;
+
 	/*
-	 * Generate all combinations of the interesting filters. We do that by
-	 * iterating 1 to (2^n-1), which generates all bitmask in between. Those
-	 * are the subsets.
-	 *
-	 * XXX This is a good demonstration why we need to keep the number of
-	 * filters low
-	 *
-	 * XXX Maybe we should also stop adding filters once the other filters
-	 * already eliminate enought tuples. Say, we know F1 alone eliminates 99%
-	 * tuples. Does it make sense to also consider [F1,F2]? Probably not. We
-	 * could track "maximum" sets, and reject combinations containing one of
-	 * those. We'd need to generate sets of increasing size, the iteration
-	 * does not do that. But that's not hard.
+	 * For each combination, build a fresh path from each eligible base path
+	 * via that base path's real constructor (except IndexPath, see the
+	 * function comment above).
 	 */
-	for (combo = 1; combo < ((uint32) 1 << nfilters); combo++)
+	foreach_ptr(List, combo, combinations)
 	{
-		List	   *subset = NIL;
-		Relids		used = NULL;
-		bool		overlap = false;
-		int			i = 0;
-		ListCell   *lcf;
-
-		foreach(lcf, filters)
+		foreach_ptr(Path, base, basepaths)
 		{
-			if (combo & ((uint32) 1 << i))
-				subset = lappend(subset, lfirst(lcf));
-			i++;
-		}
+			Path	   *newpath = NULL;
 
-		/*
-		 * Skip combinations that mix filters with overlapping build sides.
-		 * Such filters would be sourced from joins that share build
-		 * relations, so their selectivities are not independent and applying
-		 * them together at the same scan wrong - the result would be correct,
-		 * but the estimates would get smaller.
-		 */
-		foreach(lcf, subset)
-		{
-			ExpectedFilter *f = (ExpectedFilter *) lfirst(lcf);
-
-			if (bms_overlap(used, f->build_relids))
+			switch (nodeTag(base))
 			{
-				overlap = true;
-				break;
+				case T_Path:
+					if (base->pathtype == T_SeqScan)
+						newpath = create_seqscan_path(root, rel, NULL,
+													  base->parallel_workers,
+													  combo);
+					else if (base->pathtype == T_SampleScan)
+						newpath = create_samplescan_path(root, rel, NULL,
+														 combo);
+					break;
+				case T_IndexPath:
+					newpath = create_filtered_scan_path(root, base, combo);
+					break;
+				case T_BitmapHeapPath:
+					newpath = (Path *)
+						create_bitmap_heap_path(root, rel,
+												((BitmapHeapPath *) base)->bitmapqual,
+												NULL, 1.0,
+												base->parallel_workers,
+												combo);
+					break;
+				case T_TidPath:
+					newpath = (Path *)
+						create_tidscan_path(root, rel,
+											((TidPath *) base)->tidquals,
+											NULL, combo);
+					break;
+				case T_TidRangePath:
+					newpath = (Path *)
+						create_tidrangescan_path(root, rel,
+												 ((TidRangePath *) base)->tidrangequals,
+												 NULL, base->parallel_workers,
+												 combo);
+					break;
+				default:
+					break;
 			}
-			used = bms_add_members(used, f->build_relids);
-		}
-		bms_free(used);
-
-		if (overlap)
-		{
-			list_free(subset);
-			continue;
-		}
 
-		/*
-		 * All filtered paths for this combo share the same expected_filters
-		 * list.  That's safe: the list is never modified, and add_path() only
-		 * ever frees the Path node itself, not its expected_filters.
-		 */
-		foreach(lc, basepaths)
-		{
-			Path	   *base = (Path *) lfirst(lc);
-			Path	   *newpath;
-
-			newpath = create_filtered_scan_path(root, base, subset);
 			if (newpath != NULL)
 				add_path(rel, newpath);
 		}
 	}
 }
 
+/*
+ * expected_filter_selectivity_cmp
+ *	  list_sort comparator ordering ExpectedFilters by ascending selectivity,
+ *	  i.e. the most selective filter (smallest surviving fraction) first.
+ */
+static int
+expected_filter_selectivity_cmp(const ListCell *a, const ListCell *b)
+{
+	Selectivity sa = ((ExpectedFilter *) lfirst(a))->selectivity;
+	Selectivity sb = ((ExpectedFilter *) lfirst(b))->selectivity;
+
+	if (sa < sb)
+		return -1;
+	if (sa > sb)
+		return 1;
+	return 0;
+}
+
+/*
+ * find_bloom_filter_combinations
+ *	  Find the interesting Bloom filters rel could receive from a hash join
+ *	  above it (see find_interesting_bloom_filters), and return the combination
+ *	  of them worth building a path for, as a list of lists of ExpectedFilter.
+ *
+ * Following the "apply all candidates simultaneously" heuristic (Heuristic 4
+ * of the bottom-up Bloom filter paper), we build a single combination that
+ * applies as many candidates as possible at once.  We take the interesting
+ * filters most selective first and add each one whose build side does not
+ * overlap the build sides already chosen, stopping once
+ * bloom_filter_pushdown_max filters have been collected.
+ *
+ * Overlapping build sides are skipped because such filters would be sourced
+ * from joins sharing build relations, so their selectivities are not
+ * independent and applying them together would under-estimate the surviving
+ * rows.  On such a conflict we keep the more selective filter, since it sorts
+ * first.  bloom_filter_pushdown_max bounds how many filters are applied at
+ * once, which bounds the per-tuple probe cost.
+ *
+ * The result is a list of combinations (each a list of ExpectedFilter); this
+ * heuristic produces at most one combination.
+ *
+ * Note: A CustomScan provider can call it directly from its own
+ * set_rel_pathlist_hook (see generate_expected_filter_paths above).
+ */
+List *
+find_bloom_filter_combinations(PlannerInfo *root, RelOptInfo *rel)
+{
+	List	   *filters = find_interesting_bloom_filters(root, rel);
+	List	   *sorted;
+	List	   *combo = NIL;
+	Relids		used = NULL;
+	ListCell   *lc;
+
+	if (filters == NIL)
+		return NIL;
+
+	/*
+	 * Consider the most selective filters first, so that on a build-side
+	 * conflict we keep the one that discards more rows, and so that the
+	 * bloom_filter_pushdown_max cap retains the most useful filters.  Sort a
+	 * copy: "filters" is cached on the RelOptInfo and must not be reordered.
+	 */
+	sorted = list_copy(filters);
+	list_sort(sorted, expected_filter_selectivity_cmp);
+
+	foreach(lc, sorted)
+	{
+		ExpectedFilter *f = (ExpectedFilter *) lfirst(lc);
+
+		if (list_length(combo) >= bloom_filter_pushdown_max)
+			break;
+
+		/* skip a filter whose build side overlaps one already chosen */
+		if (bms_overlap(used, f->build_relids))
+			continue;
+
+		combo = lappend(combo, f);
+		used = bms_add_members(used, f->build_relids);
+	}
+
+	list_free(sorted);
+	bms_free(used);
+
+	if (combo == NIL)
+		return NIL;
+
+	return list_make1(combo);
+}
+
 /*
  * set_tablesample_rel_size
  *	  Set size estimates for a sampled relation
@@ -1674,7 +1707,7 @@ set_tablesample_rel_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *
 	required_outer = rel->lateral_relids;
 
 	/* Consider sampled scan */
-	path = create_samplescan_path(root, rel, required_outer);
+	path = create_samplescan_path(root, rel, required_outer, NIL);
 
 	/*
 	 * If the sampling method does not support repeatable scans, we must avoid
@@ -5690,7 +5723,7 @@ create_partial_bitmap_paths(PlannerInfo *root, RelOptInfo *rel,
 		return;
 
 	add_partial_path(rel, (Path *) create_bitmap_heap_path(root, rel,
-														   bitmapqual, rel->lateral_relids, 1.0, parallel_workers));
+														   bitmapqual, rel->lateral_relids, 1.0, parallel_workers, NIL));
 }
 
 /*
diff --git a/src/backend/optimizer/path/costsize.c b/src/backend/optimizer/path/costsize.c
index 218a8634226..7569b880577 100644
--- a/src/backend/optimizer/path/costsize.c
+++ b/src/backend/optimizer/path/costsize.c
@@ -176,11 +176,11 @@ bool		enable_async_append = true;
 double		bloom_filter_pushdown_threshold = 0.3;
 
 /*
- * Upper bound on the number of distinct interesting Bloom filters considered
- * for a single scan relation.  This bounds the number of additional paths
- * generated per scan (the planner enumerates non-empty subsets of the
- * interesting filters, i.e. up to 2^bloom_filter_pushdown_max - 1 extra
- * paths per base scan path).
+ * Upper bound on the number of interesting Bloom filters that may be
+ * combined into a single filter-aware scan path variant for a base
+ * relation.  This does not limit how many candidate filters are considered
+ * (see bloom_filter_pushdown_threshold) -- only how large a combination of
+ * them the planner is willing to build a path for.
  */
 int			bloom_filter_pushdown_max = 3;
 
@@ -189,8 +189,8 @@ int			bloom_filter_pushdown_max = 3;
  * side.  Bloom filters over larger joins are unlikely to be worthwhile and
  * enumerating them would inflate planning time, so we keep this small.  This
  * bounds the *size* of each candidate build side, which is distinct from
- * bloom_filter_pushdown_max that bounds how many interesting filters are
- * ultimately kept per probe relation.
+ * bloom_filter_pushdown_max, which bounds how many filters are applied
+ * together in a single scan.
  */
 int			bloom_filter_pushdown_max_build_relids = 3;
 
diff --git a/src/backend/optimizer/path/indxpath.c b/src/backend/optimizer/path/indxpath.c
index 3f5d4fa3182..a6c9a41ead1 100644
--- a/src/backend/optimizer/path/indxpath.c
+++ b/src/backend/optimizer/path/indxpath.c
@@ -344,7 +344,7 @@ create_index_paths(PlannerInfo *root, RelOptInfo *rel)
 
 		bitmapqual = choose_bitmap_and(root, rel, bitindexpaths);
 		bpath = create_bitmap_heap_path(root, rel, bitmapqual,
-										rel->lateral_relids, 1.0, 0);
+										rel->lateral_relids, 1.0, 0, NIL);
 		add_path(rel, (Path *) bpath);
 
 		/* create a partial bitmap heap path */
@@ -411,7 +411,7 @@ create_index_paths(PlannerInfo *root, RelOptInfo *rel)
 			required_outer = PATH_REQ_OUTER(bitmapqual);
 			loop_count = get_loop_count(root, rel->relid, required_outer);
 			bpath = create_bitmap_heap_path(root, rel, bitmapqual,
-											required_outer, loop_count, 0);
+											required_outer, loop_count, 0, NIL);
 			add_path(rel, (Path *) bpath);
 		}
 	}
diff --git a/src/backend/optimizer/path/tidpath.c b/src/backend/optimizer/path/tidpath.c
index 18a3654720b..83b261542ea 100644
--- a/src/backend/optimizer/path/tidpath.c
+++ b/src/backend/optimizer/path/tidpath.c
@@ -468,7 +468,7 @@ BuildParameterizedTidPaths(PlannerInfo *root, RelOptInfo *rel, List *clauses)
 		required_outer = bms_del_member(required_outer, rel->relid);
 
 		add_path(rel, (Path *) create_tidscan_path(root, rel, tidquals,
-												   required_outer));
+												   required_outer, NIL));
 	}
 }
 
@@ -520,7 +520,7 @@ create_tidscan_paths(PlannerInfo *root, RelOptInfo *rel)
 		Relids		required_outer = rel->lateral_relids;
 
 		add_path(rel, (Path *) create_tidscan_path(root, rel, tidquals,
-												   required_outer));
+												   required_outer, NIL));
 
 		/*
 		 * When the qual is CurrentOfExpr, the path that we just added is the
@@ -554,7 +554,7 @@ create_tidscan_paths(PlannerInfo *root, RelOptInfo *rel)
 		add_path(rel, (Path *) create_tidrangescan_path(root, rel,
 														tidrangequals,
 														required_outer,
-														0));
+														0, NIL));
 
 		/* If appropriate, consider parallel tid range scan. */
 		if (rel->consider_parallel && required_outer == NULL)
@@ -569,7 +569,7 @@ create_tidscan_paths(PlannerInfo *root, RelOptInfo *rel)
 																		rel,
 																		tidrangequals,
 																		required_outer,
-																		parallel_workers));
+																		parallel_workers, NIL));
 		}
 	}
 
diff --git a/src/backend/optimizer/plan/planner.c b/src/backend/optimizer/plan/planner.c
index 6de8ffa8b03..eb853d267b6 100644
--- a/src/backend/optimizer/plan/planner.c
+++ b/src/backend/optimizer/plan/planner.c
@@ -7179,7 +7179,7 @@ plan_cluster_use_sort(Oid tableOid, Oid indexOid)
 	comparisonCost = 2.0 * (indexExprCost.startup + indexExprCost.per_tuple);
 
 	/* Estimate the cost of seq scan + sort */
-	seqScanPath = create_seqscan_path(root, rel, NULL, 0);
+	seqScanPath = create_seqscan_path(root, rel, NULL, 0, NIL);
 	cost_sort(&seqScanAndSortPath, root, NIL,
 			  seqScanPath->disabled_nodes,
 			  seqScanPath->total_cost, rel->tuples, rel->reltarget->width,
